Index: serefpolicy-contrib-20140730/cachefilesd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/cachefilesd.te
+++ serefpolicy-contrib-20140730/cachefilesd.te
@@ -1,52 +1,124 @@
 policy_module(cachefilesd, 1.1.0)
 
-########################################
+###############################################################################
 #
 # Declarations
 #
 
+#
+# Files in the cache are created by the cachefiles module with security ID
+# cachefiles_var_t
+#
+type cachefiles_var_t;
+files_type(cachefiles_var_t)
+
+#
+# The /dev/cachefiles character device has security ID cachefiles_dev_t
+#
+type cachefiles_dev_t;
+dev_node(cachefiles_dev_t)
+
+#
+# The cachefilesd daemon normally runs with security ID cachefilesd_t
+#
 type cachefilesd_t;
 type cachefilesd_exec_t;
 init_daemon_domain(cachefilesd_t, cachefilesd_exec_t)
 
-type cachefilesd_initrc_exec_t;
-init_script_file(cachefilesd_initrc_exec_t)
-
-type cachefilesd_cache_t;
-files_type(cachefilesd_cache_t)
-
+#
+# The cachefilesd daemon pid file context
+#
 type cachefilesd_var_run_t;
 files_pid_file(cachefilesd_var_run_t)
 
-########################################
 #
-# Local policy
+# The CacheFiles kernel module causes processes accessing the cache files to do
+# so acting as security ID cachefiles_kernel_t
+#
+type cachefiles_kernel_t;
+domain_type(cachefiles_kernel_t)
+domain_obj_id_change_exemption(cachefiles_kernel_t)
+role system_r types cachefiles_kernel_t;
+
+###############################################################################
 #
+# Permit RPM to deal with files in the cache
+#
+optional_policy(`
+	rpm_use_script_fds(cachefilesd_t)
+')
 
+###############################################################################
+#
+# cachefilesd local policy
+#
+# These define what cachefilesd is permitted to do.  This doesn't include very
+# much: startup stuff, logging, pid file, scanning the cache superstructure and
+# deleting files from the cache.  It is not permitted to read/write files in
+# the cache.
+#
+# Check in /usr/share/selinux/devel/include/ for macros to use instead of allow
+# rules.
+#
 allow cachefilesd_t self:capability { setuid setgid sys_admin dac_override };
 
+# Allow manipulation of pid file
+allow cachefilesd_t cachefilesd_var_run_t:file create_file_perms;
 manage_files_pattern(cachefilesd_t, cachefilesd_var_run_t, cachefilesd_var_run_t)
+manage_dirs_pattern(cachefilesd_t, cachefilesd_var_run_t, cachefilesd_var_run_t)
 files_pid_filetrans(cachefilesd_t, cachefilesd_var_run_t, file)
+files_create_as_is_all_files(cachefilesd_t)
 
-manage_dirs_pattern(cachefilesd_t, cachefilesd_cache_t, cachefilesd_cache_t)
-manage_files_pattern(cachefilesd_t, cachefilesd_cache_t, cachefilesd_cache_t)
-
-dev_rw_cachefiles(cachefilesd_t)
+# Allow access to cachefiles device file
+allow cachefilesd_t cachefiles_dev_t:chr_file rw_file_perms;
 
-files_create_all_files_as(cachefilesd_t)
-files_read_etc_files(cachefilesd_t)
+# Allow access to cache superstructure
+manage_dirs_pattern(cachefilesd_t, cachefiles_var_t, cachefiles_var_t)
+manage_files_pattern(cachefilesd_t, cachefiles_var_t, cachefiles_var_t)
 
+# Permit statfs on the backing filesystem
 fs_getattr_xattr_fs(cachefilesd_t)
 
+# Basic access
+logging_send_syslog_msg(cachefilesd_t)
+init_dontaudit_use_script_ptys(cachefilesd_t)
 term_dontaudit_use_generic_ptys(cachefilesd_t)
 term_dontaudit_getattr_unallocated_ttys(cachefilesd_t)
 
-logging_send_syslog_msg(cachefilesd_t)
+###############################################################################
+#
+# When cachefilesd invokes the kernel module to begin caching, it has to tell
+# the kernel module the security context in which it should act, and this
+# policy has to approve that.
+#
+# There are two parts to this:
+#
+#   (1) the security context used by the module to access files in the cache,
+#       as set by the 'secctx' command in /etc/cachefilesd.conf, and
+#
+allow cachefilesd_t cachefiles_kernel_t:kernel_service { use_as_override };
 
-miscfiles_read_localization(cachefilesd_t)
+#
+#   (2) the label that will be assigned to new files and directories created in
+#       the cache by the module, which will be the same as the label on the
+#       directory pointed to by the 'dir' command.
+#
+allow cachefilesd_t cachefiles_var_t:kernel_service { create_files_as };
 
-init_dontaudit_use_script_ptys(cachefilesd_t)
+###############################################################################
+#
+# cachefiles kernel module local policy
+#
+# This governs what the kernel module is allowed to do the contents of the
+# cache.
+#
+allow cachefiles_kernel_t self:capability { dac_override dac_read_search };
 
-optional_policy(`
-	rpm_use_script_fds(cachefilesd_t)
-')
+manage_dirs_pattern(cachefiles_kernel_t, cachefiles_var_t, cachefiles_var_t)
+manage_files_pattern(cachefiles_kernel_t, cachefiles_var_t, cachefiles_var_t)
+
+fs_getattr_xattr_fs(cachefiles_kernel_t)
+
+dev_search_sysfs(cachefiles_kernel_t)
+
+init_sigchld_script(cachefiles_kernel_t)
Index: serefpolicy-contrib-20140730/calamaris.if
===================================================================
--- serefpolicy-contrib-20140730.orig/calamaris.if
+++ serefpolicy-contrib-20140730/calamaris.if
@@ -42,7 +42,7 @@ interface(`calamaris_run',`
 		attribute_role calamaris_roles;
 	')
 
-	lightsquid_domtrans($1)
+	calamaris_domtrans($1)
 	roleattribute $2 calamaris_roles;
 ')
 
Index: serefpolicy-contrib-20140730/calamaris.te
===================================================================
--- serefpolicy-contrib-20140730.orig/calamaris.te
+++ serefpolicy-contrib-20140730/calamaris.te
@@ -41,19 +41,23 @@ kernel_read_system_state(calamaris_t)
 
 corecmd_exec_bin(calamaris_t)
 
+corenet_all_recvfrom_netlabel(calamaris_t)
+corenet_tcp_sendrecv_generic_if(calamaris_t)
+corenet_udp_sendrecv_generic_if(calamaris_t)
+corenet_tcp_sendrecv_generic_node(calamaris_t)
+corenet_udp_sendrecv_generic_node(calamaris_t)
+corenet_tcp_sendrecv_all_ports(calamaris_t)
+corenet_udp_sendrecv_all_ports(calamaris_t)
+
 dev_read_urand(calamaris_t)
 
-files_read_usr_files(calamaris_t)
+files_search_pids(calamaris_t)
 files_read_etc_runtime_files(calamaris_t)
 
-libs_read_lib_files(calamaris_t)
-
 auth_use_nsswitch(calamaris_t)
 
 logging_send_syslog_msg(calamaris_t)
 
-miscfiles_read_localization(calamaris_t)
-
 userdom_dontaudit_list_user_home_dirs(calamaris_t)
 
 optional_policy(`
Index: serefpolicy-contrib-20140730/callweaver.te
===================================================================
--- serefpolicy-contrib-20140730.orig/callweaver.te
+++ serefpolicy-contrib-20140730/callweaver.te
@@ -84,4 +84,3 @@ term_use_ptmx(callweaver_t)
 
 auth_use_nsswitch(callweaver_t)
 
-miscfiles_read_localization(callweaver_t)
Index: serefpolicy-contrib-20140730/canna.if
===================================================================
--- serefpolicy-contrib-20140730.orig/canna.if
+++ serefpolicy-contrib-20140730/canna.if
@@ -43,9 +43,13 @@ interface(`canna_admin',`
 		type canna_var_run_t, canna_initrc_exec_t;
 	')
 
-	allow $1 canna_t:process { ptrace signal_perms };
+	allow $1 canna_t:process signal_perms;
 	ps_process_pattern($1, canna_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 canna_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, canna_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 canna_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/canna.te
===================================================================
--- serefpolicy-contrib-20140730.orig/canna.te
+++ serefpolicy-contrib-20140730/canna.te
@@ -52,7 +52,6 @@ files_pid_filetrans(canna_t, canna_var_r
 kernel_read_kernel_sysctls(canna_t)
 kernel_read_system_state(canna_t)
 
-corenet_all_recvfrom_unlabeled(canna_t)
 corenet_all_recvfrom_netlabel(canna_t)
 corenet_tcp_sendrecv_generic_if(canna_t)
 corenet_tcp_sendrecv_generic_node(canna_t)
@@ -68,16 +67,12 @@ fs_search_auto_mountpoints(canna_t)
 
 domain_use_interactive_fds(canna_t)
 
-files_read_etc_files(canna_t)
 files_read_etc_runtime_files(canna_t)
-files_read_usr_files(canna_t)
 files_search_tmp(canna_t)
 files_dontaudit_read_root_files(canna_t)
 
 logging_send_syslog_msg(canna_t)
 
-miscfiles_read_localization(canna_t)
-
 sysnet_read_config(canna_t)
 
 userdom_dontaudit_use_unpriv_user_fds(canna_t)
Index: serefpolicy-contrib-20140730/ccs.if
===================================================================
--- serefpolicy-contrib-20140730.orig/ccs.if
+++ serefpolicy-contrib-20140730/ccs.if
@@ -98,20 +98,24 @@ interface(`ccs_manage_config',`
 interface(`ccs_admin',`
 	gen_require(`
 		type ccs_t, ccs_initrc_exec_t, cluster_conf_t;
-		type ccs_var_lib_t_t, ccs_var_log_t;
+		type ccs_var_lib_t, ccs_var_log_t;
 		type ccs_var_run_t, ccs_tmp_t;
 	')
 
-	allow $1 ccs_t:process { ptrace signal_perms };
+	allow $1 ccs_t:process { signal_perms };
 	ps_process_pattern($1, ccs_t)
 
+    tunable_policy(`deny_ptrace',`',`
+        allow $1 ccs_t:process ptrace;
+    ')
+
 	init_labeled_script_domtrans($1, ccs_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 ccs_initrc_exec_t system_r;
 	allow $2 system_r;
 
 	files_search_etc($1)
-	admin_pattern($1, ccs_conf_t)
+	admin_pattern($1, cluster_conf_t)
 
 	files_search_var_lib($1)
 	admin_pattern($1, ccs_var_lib_t)
Index: serefpolicy-contrib-20140730/ccs.te
===================================================================
--- serefpolicy-contrib-20140730.orig/ccs.te
+++ serefpolicy-contrib-20140730/ccs.te
@@ -1,4 +1,4 @@
-policy_module(ccs, 1.7.0)
+policy_module(ccs, 1.6.0)
 
 ########################################
 #
@@ -37,7 +37,7 @@ files_pid_file(ccs_var_run_t)
 
 allow ccs_t self:capability { ipc_owner ipc_lock sys_nice sys_resource sys_admin };
 allow ccs_t self:process { signal setrlimit setsched };
-dontaudit ccs_t self:process ptrace;
+
 allow ccs_t self:fifo_file rw_fifo_file_perms;
 allow ccs_t self:unix_stream_socket { accept connectto listen };
 allow ccs_t self:tcp_socket { accept listen };
@@ -75,7 +75,6 @@ kernel_read_kernel_sysctls(ccs_t)
 corecmd_list_bin(ccs_t)
 corecmd_exec_bin(ccs_t)
 
-corenet_all_recvfrom_unlabeled(ccs_t)
 corenet_all_recvfrom_netlabel(ccs_t)
 corenet_tcp_sendrecv_generic_if(ccs_t)
 corenet_udp_sendrecv_generic_if(ccs_t)
@@ -95,28 +94,25 @@ corenet_udp_bind_netsupport_port(ccs_t)
 
 dev_read_urand(ccs_t)
 
-files_read_etc_files(ccs_t)
 files_read_etc_runtime_files(ccs_t)
 
 init_rw_script_tmp_files(ccs_t)
+init_signal(ccs_t)
 
 logging_send_syslog_msg(ccs_t)
 
-miscfiles_read_localization(ccs_t)
-
 sysnet_dns_name_resolve(ccs_t)
 
 userdom_manage_unpriv_user_shared_mem(ccs_t)
 userdom_manage_unpriv_user_semaphores(ccs_t)
 
 ifdef(`hide_broken_symptoms',`
-	kernel_manage_unlabeled_files(ccs_t)
 	corecmd_dontaudit_write_bin_dirs(ccs_t)
+	files_manage_isid_type_files(ccs_t)
 ')
 
 optional_policy(`
-	aisexec_stream_connect(ccs_t)
-	corosync_stream_connect(ccs_t)
+	rhcs_stream_connect_cluster(ccs_t)
 ')
 
 optional_policy(`
Index: serefpolicy-contrib-20140730/cdrecord.if
===================================================================
--- serefpolicy-contrib-20140730.orig/cdrecord.if
+++ serefpolicy-contrib-20140730/cdrecord.if
@@ -27,6 +27,9 @@ interface(`cdrecord_role',`
 
 	allow cdrecord_t $2:unix_stream_socket rw_socket_perms;
 
-	allow $2 cdrecord_t:process { ptrace signal_perms };
+	allow $2 cdrecord_t:process signal_perms;
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 cdrecord_t:process ptrace;
+	')
 	ps_process_pattern($2, cdrecord_t)
 ')
Index: serefpolicy-contrib-20140730/cdrecord.te
===================================================================
--- serefpolicy-contrib-20140730.orig/cdrecord.te
+++ serefpolicy-contrib-20140730/cdrecord.te
@@ -41,8 +41,6 @@ dev_read_sysfs(cdrecord_t)
 domain_interactive_fd(cdrecord_t)
 domain_use_interactive_fds(cdrecord_t)
 
-files_read_etc_files(cdrecord_t)
-
 term_use_controlling_term(cdrecord_t)
 term_list_ptys(cdrecord_t)
 
@@ -52,10 +50,7 @@ storage_write_scsi_generic(cdrecord_t)
 
 logging_send_syslog_msg(cdrecord_t)
 
-miscfiles_read_localization(cdrecord_t)
-
-userdom_use_user_terminals(cdrecord_t)
-userdom_read_user_home_content_files(cdrecord_t)
+userdom_use_inherited_user_terminals(cdrecord_t)
 
 tunable_policy(`cdrecord_read_content && use_nfs_home_dirs',`
 	fs_list_auto_mountpoints(cdrecord_t)
@@ -104,11 +99,7 @@ tunable_policy(`cdrecord_read_content',`
 	userdom_dontaudit_read_user_home_content_files(cdrecord_t)
 ')
 
-tunable_policy(`use_nfs_home_dirs',`
-	files_search_mnt(cdrecord_t)
-	fs_read_nfs_files(cdrecord_t)
-	fs_read_nfs_symlinks(cdrecord_t)
-')
+userdom_home_manager(cdrecord_t)
 
 optional_policy(`
 	resmgr_stream_connect(cdrecord_t)
Index: serefpolicy-contrib-20140730/certmaster.if
===================================================================
--- serefpolicy-contrib-20140730.orig/certmaster.if
+++ serefpolicy-contrib-20140730/certmaster.if
@@ -117,13 +117,16 @@ interface(`certmaster_manage_log',`
 interface(`certmaster_admin',`
 	gen_require(`
 		type certmaster_t, certmaster_var_run_t, certmaster_var_lib_t;
-		type certmaster_etc_rw_t, certmaster_var_log_t;
-		type certmaster_initrc_exec_t;
+		type certmaster_etc_rw_t, certmaster_var_log_t, certmaster_initrc_exec_t;
 	')
 
-	allow $1 certmaster_t:process { ptrace signal_perms };
+	allow $1 certmaster_t:process signal_perms;
 	ps_process_pattern($1, certmaster_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 certmaster_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, certmaster_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 certmaster_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/certmaster.te
===================================================================
--- serefpolicy-contrib-20140730.orig/certmaster.te
+++ serefpolicy-contrib-20140730/certmaster.te
@@ -65,11 +65,10 @@ corenet_tcp_sendrecv_certmaster_port(cer
 dev_read_urand(certmaster_t)
 
 files_list_var(certmaster_t)
-files_search_etc(certmaster_t)
-files_read_usr_files(certmaster_t)
 
 auth_use_nsswitch(certmaster_t)
 
-miscfiles_read_localization(certmaster_t)
 miscfiles_manage_generic_cert_dirs(certmaster_t)
 miscfiles_manage_generic_cert_files(certmaster_t)
+
+mta_send_mail(certmaster_t)
Index: serefpolicy-contrib-20140730/certmonger.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/certmonger.fc
+++ serefpolicy-contrib-20140730/certmonger.fc
@@ -2,6 +2,8 @@
 
 /usr/sbin/certmonger	--	gen_context(system_u:object_r:certmonger_exec_t,s0)
 
+/usr/lib/ipa/certmonger(/.*)?		gen_context(system_u:object_r:certmonger_unconfined_exec_t,s0)
+
 /var/lib/certmonger(/.*)?	gen_context(system_u:object_r:certmonger_var_lib_t,s0)
 
 /var/run/certmonger.*	gen_context(system_u:object_r:certmonger_var_run_t,s0)
Index: serefpolicy-contrib-20140730/certmonger.if
===================================================================
--- serefpolicy-contrib-20140730.orig/certmonger.if
+++ serefpolicy-contrib-20140730/certmonger.if
@@ -160,16 +160,20 @@ interface(`certmonger_admin',`
 	')
 
 	ps_process_pattern($1, certmonger_t)
-	allow $1 certmonger_t:process { ptrace signal_perms };
+	allow $1 certmonger_t:process signal_perms;
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 certmonger_t:process ptrace;
+	')
 
 	certmonger_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 certmonger_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_search_var_lib($1)
+	files_list_var_lib($1)
 	admin_pattern($1, certmonger_var_lib_t)
 
-	files_search_pids($1)
+	files_list_pids($1)
 	admin_pattern($1, certmonger_var_run_t)
 ')
Index: serefpolicy-contrib-20140730/certmonger.te
===================================================================
--- serefpolicy-contrib-20140730.orig/certmonger.te
+++ serefpolicy-contrib-20140730/certmonger.te
@@ -18,6 +18,9 @@ files_type(certmonger_var_lib_t)
 type certmonger_var_run_t;
 files_pid_file(certmonger_var_run_t)
 
+type certmonger_unconfined_exec_t;
+application_executable_file(certmonger_unconfined_exec_t)
+
 ########################################
 #
 # Local policy
@@ -26,10 +29,12 @@ files_pid_file(certmonger_var_run_t)
 allow certmonger_t self:capability { dac_override dac_read_search setgid setuid kill sys_nice };
 dontaudit certmonger_t self:capability sys_tty_config;
 allow certmonger_t self:capability2 block_suspend;
+
 allow certmonger_t self:process { getsched setsched sigkill signal };
-allow certmonger_t self:fifo_file rw_fifo_file_perms;
-allow certmonger_t self:unix_stream_socket { accept listen };
-allow certmonger_t self:tcp_socket { accept listen };
+allow certmonger_t self:fifo_file rw_file_perms;
+allow certmonger_t self:unix_stream_socket create_stream_socket_perms;
+allow certmonger_t self:tcp_socket create_stream_socket_perms;
+allow certmonger_t self:netlink_route_socket r_netlink_socket_perms;
 
 manage_dirs_pattern(certmonger_t, certmonger_var_lib_t, certmonger_var_lib_t)
 manage_files_pattern(certmonger_t, certmonger_var_lib_t, certmonger_var_lib_t)
@@ -41,6 +46,7 @@ files_pid_filetrans(certmonger_t, certmo
 
 kernel_read_kernel_sysctls(certmonger_t)
 kernel_read_system_state(certmonger_t)
+kernel_read_network_state(certmonger_t)
 
 corenet_all_recvfrom_unlabeled(certmonger_t)
 corenet_all_recvfrom_netlabel(certmonger_t)
@@ -49,17 +55,25 @@ corenet_tcp_sendrecv_generic_node(certmo
 
 corenet_sendrecv_certmaster_client_packets(certmonger_t)
 corenet_tcp_connect_certmaster_port(certmonger_t)
+
+corenet_tcp_connect_http_port(certmonger_t)
+corenet_tcp_connect_http_cache_port(certmonger_t)
+
+corenet_tcp_connect_ldap_port(certmonger_t)
+
+corenet_tcp_connect_pki_ca_port(certmonger_t)
 corenet_tcp_sendrecv_certmaster_port(certmonger_t)
 
 corecmd_exec_bin(certmonger_t)
 corecmd_exec_shell(certmonger_t)
 
+dev_read_rand(certmonger_t)
 dev_read_urand(certmonger_t)
 
 domain_use_interactive_fds(certmonger_t)
 
-files_read_usr_files(certmonger_t)
 files_list_tmp(certmonger_t)
+files_list_home(certmonger_t)
 
 fs_search_cgroup_dirs(certmonger_t)
 
@@ -70,16 +84,17 @@ init_getattr_all_script_files(certmonger
 
 logging_send_syslog_msg(certmonger_t)
 
-miscfiles_read_localization(certmonger_t)
-miscfiles_manage_generic_cert_files(certmonger_t)
+miscfiles_manage_all_certs(certmonger_t)
+
+systemd_exec_systemctl(certmonger_t)
 
 userdom_search_user_home_content(certmonger_t)
 
 optional_policy(`
-	apache_initrc_domtrans(certmonger_t)
 	apache_search_config(certmonger_t)
 	apache_signal(certmonger_t)
 	apache_signull(certmonger_t)
+	apache_systemctl(certmonger_t)
 ')
 
 optional_policy(`
@@ -92,11 +107,51 @@ optional_policy(`
 ')
 
 optional_policy(`
-	kerberos_read_keytab(certmonger_t)
+	dirsrv_manage_config(certmonger_t)
+	dirsrv_signal(certmonger_t)
+	dirsrv_signull(certmonger_t)
+')
+
+optional_policy(`
+    ipa_manage_lib(certmonger_t)
+')
+
+optional_policy(`
 	kerberos_use(certmonger_t)
+	kerberos_read_keytab(certmonger_t)
 ')
 
 optional_policy(`
 	pcscd_read_pid_files(certmonger_t)
 	pcscd_stream_connect(certmonger_t)
 ')
+
+optional_policy(`
+	pki_rw_tomcat_cert(certmonger_t)
+	pki_read_tomcat_lib_files(certmonger_t)
+')
+
+########################################
+#
+# certmonger_unconfined_script_t local policy
+#
+
+optional_policy(`
+	type certmonger_unconfined_t;
+	domain_type(certmonger_unconfined_t)
+
+	domain_entry_file(certmonger_unconfined_t, certmonger_unconfined_exec_t)
+	role system_r types certmonger_unconfined_t;
+
+	domtrans_pattern(certmonger_t, certmonger_unconfined_exec_t, certmonger_unconfined_t)
+
+	allow certmonger_t certmonger_unconfined_exec_t:dir search_dir_perms;
+	allow certmonger_t certmonger_unconfined_exec_t:dir read_file_perms;
+	allow certmonger_t certmonger_unconfined_exec_t:file ioctl;
+
+	init_domtrans_script(certmonger_unconfined_t)
+
+	optional_policy(`
+		unconfined_domain(certmonger_unconfined_t)
+	')
+')
Index: serefpolicy-contrib-20140730/certwatch.te
===================================================================
--- serefpolicy-contrib-20140730.orig/certwatch.te
+++ serefpolicy-contrib-20140730/certwatch.te
@@ -20,33 +20,45 @@ role certwatch_roles types certwatch_t;
 
 allow certwatch_t self:capability sys_nice;
 allow certwatch_t self:process { setsched getsched };
+allow certwatch_t self:tcp_socket create_stream_socket_perms;
 
+kernel_read_system_state(certwatch_t)
+
+corecmd_exec_bin(certwatch_t)
+
+dev_read_rand(certwatch_t)
 dev_read_urand(certwatch_t)
 
-files_read_etc_files(certwatch_t)
-files_read_usr_files(certwatch_t)
 files_read_usr_symlinks(certwatch_t)
 files_list_tmp(certwatch_t)
 
 fs_list_inotifyfs(certwatch_t)
 
 auth_manage_cache(certwatch_t)
+auth_read_passwd(certwatch_t)
 auth_var_filetrans_cache(certwatch_t)
 
 logging_send_syslog_msg(certwatch_t)
 
 miscfiles_read_all_certs(certwatch_t)
-miscfiles_read_localization(certwatch_t)
+miscfiles_manage_generic_cert_dirs(certwatch_t)
+
+sysnet_read_config(certwatch_t)
 
-userdom_use_user_terminals(certwatch_t)
-userdom_dontaudit_list_user_home_dirs(certwatch_t)
+userdom_use_inherited_user_terminals(certwatch_t)
+userdom_dontaudit_list_admin_dir(certwatch_t)
 
 optional_policy(`
+	apache_domtrans(certwatch_t)
 	apache_exec_modules(certwatch_t)
 	apache_read_config(certwatch_t)
 ')
 
 optional_policy(`
+    mta_send_mail(certwatch_t)
+')
+
+optional_policy(`
 	cron_system_entry(certwatch_t, certwatch_exec_t)
 ')
 
Index: serefpolicy-contrib-20140730/cfengine.if
===================================================================
--- serefpolicy-contrib-20140730.orig/cfengine.if
+++ serefpolicy-contrib-20140730/cfengine.if
@@ -13,7 +13,6 @@
 template(`cfengine_domain_template',`
 	gen_require(`
 		attribute cfengine_domain;
-		type cfengine_log_t, cfengine_var_lib_t;
 	')
 
 	########################################
@@ -30,7 +29,29 @@ template(`cfengine_domain_template',`
 	# Policy
 	#
 
+	kernel_read_system_state(cfengine_$1_t)
+
 	auth_use_nsswitch(cfengine_$1_t)
+
+	logging_send_syslog_msg(cfengine_$1_t)
+')
+
+######################################
+## <summary>
+##  Search cfengine lib files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`cfengine_search_lib_files',`
+	gen_require(`
+		type cfengine_var_lib_t;
+	')
+
+	allow $1 cfengine_var_lib_t:dir search_dir_perms;
 ')
 
 ########################################
@@ -71,6 +92,43 @@ interface(`cfengine_dontaudit_write_log_
 	dontaudit $1 cfengine_var_log_t:file write_file_perms;
 ')
 
+#####################################
+## <summary>
+##      Allow the specified domain to append cfengine's log files.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`cfengine_append_inherited_log',`
+        gen_require(`
+                type cfengine_var_log_t;
+        ')
+
+        cfengine_search_lib_files($1)
+		allow $1 cfengine_var_log_t:file { getattr append ioctl lock };
+')
+
+####################################
+## <summary>
+##      Dontaudit the specified domain to write cfengine's log files.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`cfengine_dontaudit_write_log',`
+        gen_require(`
+                type cfengine_var_log_t;
+        ')
+
+		dontaudit $1 cfengine_var_log_t:file write;
+')
+
 ########################################
 ## <summary>
 ##	All of the rules required to
@@ -94,7 +152,7 @@ interface(`cfengine_admin',`
 		type cfengine_initrc_exec_t, cfengine_log_t, cfengine_var_lib_t;
 	')
 
-	allow $1 cfengine_domain:process { ptrace signal_perms };
+	allow $1 cfengine_domain:process { signal_perms };
 	ps_process_pattern($1, cfengine_domain)
 
 	init_labeled_script_domtrans($1, cfengine_initrc_exec_t)
@@ -105,3 +163,4 @@ interface(`cfengine_admin',`
 	files_search_var_lib($1)
 	admin_pattern($1, { cfengine_log_t cfengine_var_lib_t })
 ')
+
Index: serefpolicy-contrib-20140730/cfengine.te
===================================================================
--- serefpolicy-contrib-20140730.orig/cfengine.te
+++ serefpolicy-contrib-20140730/cfengine.te
@@ -41,18 +41,13 @@ create_files_pattern(cfengine_domain, cf
 setattr_files_pattern(cfengine_domain, cfengine_log_t, cfengine_log_t)
 logging_log_filetrans(cfengine_domain, cfengine_log_t, dir)
 
-kernel_read_system_state(cfengine_domain)
-
 corecmd_exec_bin(cfengine_domain)
 corecmd_exec_shell(cfengine_domain)
 
 dev_read_urand(cfengine_domain)
 dev_read_sysfs(cfengine_domain)
 
-logging_send_syslog_msg(cfengine_domain)
-
-miscfiles_read_localization(cfengine_domain)
-
+sysnet_dns_name_resolve(cfengine_domain)
 sysnet_domtrans_ifconfig(cfengine_domain)
 
 ########################################
@@ -69,7 +64,7 @@ domain_read_all_domains_state(cfengine_e
 # Monitord local policy
 #
 
-kernel_read_hotplug_sysctls(cfengine_monitord_t)
+kernel_read_usermodehelper_state(cfengine_monitord_t)
 kernel_read_network_state(cfengine_monitord_t)
 
 domain_read_all_domains_state(cfengine_monitord_t)
Index: serefpolicy-contrib-20140730/cgroup.if
===================================================================
--- serefpolicy-contrib-20140730.orig/cgroup.if
+++ serefpolicy-contrib-20140730/cgroup.if
@@ -171,8 +171,26 @@ interface(`cgroup_admin',`
 		type cgrules_etc_t, cgclear_t;
 	')
 
-	allow $1 { cgclear_t cgconfig_t cgred_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { cgclear_t cgconfig_t cgred_t })
+	allow $1 cgclear_t:process signal_perms;
+	ps_process_pattern($1, cgclear_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 cgclear_t:process ptrace;
+	')
+
+	allow $1 cgconfig_t:process signal_perms;
+	ps_process_pattern($1, cgconfig_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 cgconfig_t:process ptrace;
+	')
+
+	allow $1 cgred_t:process signal_perms;
+	ps_process_pattern($1, cgred_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 cgred_t:process ptrace;
+	')
 
 	admin_pattern($1, { cgconfig_etc_t cgrules_etc_t })
 	files_list_etc($1)
Index: serefpolicy-contrib-20140730/cgroup.te
===================================================================
--- serefpolicy-contrib-20140730.orig/cgroup.te
+++ serefpolicy-contrib-20140730/cgroup.te
@@ -25,8 +25,8 @@ files_pid_file(cgred_var_run_t)
 type cgrules_etc_t;
 files_config_file(cgrules_etc_t)
 
-type cgconfig_t;
-type cgconfig_exec_t;
+type cgconfig_t alias cgconfigparser_t;
+type cgconfig_exec_t alias cgconfigparser_exec_t;
 init_daemon_domain(cgconfig_t, cgconfig_exec_t)
 
 type cgconfig_initrc_exec_t;
@@ -42,10 +42,12 @@ files_config_file(cgconfig_etc_t)
 
 allow cgclear_t self:capability { dac_read_search dac_override sys_admin };
 
-allow cgclear_t cgconfig_etc_t:file read_file_perms;
+read_files_pattern(cgclear_t, cgconfig_etc_t, cgconfig_etc_t)
 
 kernel_read_system_state(cgclear_t)
 
+auth_use_nsswitch(cgclear_t)
+
 domain_setpriority_all_domains(cgclear_t)
 
 fs_manage_cgroup_dirs(cgclear_t)
@@ -64,23 +66,25 @@ allow cgconfig_t cgconfig_etc_t:file rea
 kernel_list_unlabeled(cgconfig_t)
 kernel_read_system_state(cgconfig_t)
 
-files_read_etc_files(cgconfig_t)
-
 fs_manage_cgroup_dirs(cgconfig_t)
 fs_manage_cgroup_files(cgconfig_t)
 fs_mount_cgroup(cgconfig_t)
 fs_mounton_cgroup(cgconfig_t)
 fs_unmount_cgroup(cgconfig_t)
 
+auth_use_nsswitch(cgconfig_t)
+
 ########################################
 #
 # cgred local policy
 #
+allow cgred_t self:capability { chown fsetid net_admin sys_admin dac_override sys_ptrace };
+allow cgred_t self:process signal_perms;
 
-allow cgred_t self:capability { chown fsetid net_admin sys_admin sys_ptrace dac_override };
 allow cgred_t self:netlink_socket { write bind create read };
 allow cgred_t self:unix_dgram_socket { write create connect };
 
+allow cgred_t cgconfig_etc_t:file read_file_perms;
 allow cgred_t cgrules_etc_t:file read_file_perms;
 
 allow cgred_t cgred_log_t:file { append_file_perms create_file_perms setattr_file_perms };
@@ -99,10 +103,11 @@ domain_setpriority_all_domains(cgred_t)
 files_getattr_all_files(cgred_t)
 files_getattr_all_sockets(cgred_t)
 files_read_all_symlinks(cgred_t)
-files_read_etc_files(cgred_t)
 
-fs_write_cgroup_files(cgred_t)
+fs_manage_cgroup_dirs(cgred_t)
+fs_manage_cgroup_files(cgred_t)
+fs_list_inotifyfs(cgred_t)
 
-logging_send_syslog_msg(cgred_t)
+auth_use_nsswitch(cgred_t)
 
-miscfiles_read_localization(cgred_t)
+logging_send_syslog_msg(cgred_t)
